#include "datastructures.h"
#include <stdlib.h>
#include <signal.h>
#include <stdio.h>

bool Marks::subset() {
    /*
       return subsetp(&sens.front(), &imm.front(), sens.size(), imm.size());
       for (Marks::Container::iterator it = sens.begin()+subsetNumber; it != sens.end(); ++it) {
       if (std::find(imm.begin(), imm.end(), *it) == imm.end()) {
       subsetNumber = std::distance(sens.begin(), it);
       return false;
       }
       }
       subsetNumber = sens.size();
       return true;
       */
    // bypass range checks, can safely comment the following two lines out for increased range checks
    int *sens = &this->sens.front();
    int *imm = &this->imm.front();
    int len_s = this->sens.size();
    int len_im = this->imm.size();
    //std::cout << subsetNumber << "/" << len_b << std::endl;
    int i = subsetNumber;
    if (immPlace >= 0) {
        //std::cout << immPlace << "/" << len_b << std::endl;
        int current = sens[i];
        int index_im;
        for(index_im = immPlace; index_im < len_im && current != imm[index_im]; ++index_im);
        // still not found
        if (index_im == len_im) {
            immPlace = len_im;
            return false;
        }
        i++;
    }
    for (; i < len_s; ++i) {
        int current = sens[i];
        int index_im;
        for(index_im=len_im-1; index_im >= 0 && current != imm[index_im]; --index_im);
        // not found
        if (index_im < 0) {
            subsetNumber = i;
            immPlace = len_im;
            return false;
        }
    }
    subsetNumber = len_s;
    immPlace = -1;
    return true;
}


void init_dyn_int_List(struct dyn_int_List *x, int n) {
    int i;
    for (i=0; i<n; i++) {
        struct dyn_int_List a = {0,0,NULL};
        x[i] = a;
    }
}

void print_constraint(struct constraint c) {
	int j;
	for (j=0;j<c.lhs_size;j++) {
		printf(" %s ", j > 0 || !c.pos[j] ? c.pos[j] ? "+" : "-" : "");
		if (c.lhs[j] < 0)
			printf("%i", c.pos[j]* -(c.lhs[j] + 1));
		else
			printf("%i x%i", c.pos[j], c.lhs[j]);
	}
	if (c.constr_type != OBJ)
		printf ("%s %i", c.constr_type == LE ? " <=" : c.constr_type == GE ? " >=" : " =", c.rhs);
	puts("");
}

/* Adds return tables. Does not allocate a new table, the first table is overwritten. */
void add_ret_tables(struct RET_table * t1, struct RET_table t2) {
	t1->dl += t2.dl;
	t1->dlf += t2.dlf;
	t1->disc_routing += t2.disc_routing;
	t1->terminate |= t2.terminate;
}

void add_result_to_ret_table(struct RET_table * t, int result) {
    switch (result) {
		case (RET_DLF):
			t->dlf++;
			break;
		case (RET_DL_NOT_MIN):
		case (RET_DL_MIN):
			t->dl++;
			break;
		case RET_DISC_ROUTING:
			t->disc_routing++;
			break;
		default:
           	fprintf(stderr, "ERROR: process returned dl==%i.\n", result);
            kill(0,SIGTERM);
	}
}
