//
//  memorycache.cpp
//  PS
//
//  Created by Bernard van Gastel on 22-11-11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#ifndef _MEMORYCACHE_H_
#define _MEMORYCACHE_H_

#include <iostream>
#include "stack.h"

#ifdef DEBUG
#define CHUNK 1
#else
#define CHUNK 64
#endif

template <class T>
class CachedInstance {
public:
    CachedInstance *next;
};

template <class T>
class CacheStack : public Stack< CachedInstance<T> > {
public:
#ifdef DEBUG
    ~CacheStack() {
        T *retval;
        while ((retval = (T*)this->get())) {
            free(retval);
        }
    }
#endif
};

template <class T>
class CacheInstances {
    static CacheStack< T > instanceCache;
public:
    //virtual ~CacheInstances() {
    //}
    static void operator delete(void *pointer, std::size_t size) {
        T *c = (T*)pointer;
        instanceCache.put( (CachedInstance<T>*)c);
    }
    static void *operator new(size_t size) {
        T *retval;
        retval = (T*)instanceCache.get();
        if (!retval) {
            retval = (T*)malloc(CHUNK*size);
            for (int i = 1; i < CHUNK; ++i) {
                instanceCache.put((CachedInstance<T>*) &retval[i]);
            }
        }
        return retval;
    }
};
template <typename T> CacheStack< T > CacheInstances<T>::instanceCache;

#endif
