/****************************/
/* XY SHORTEST PATH ROUTING */
/****************************/

#include "2dd_mesh_definitions.h"


// The routing function.
ResourceList* inst_routing(const Resource &c, Procnode* d, const Params* dim, ResourceList* frs) {
    ResourceList *hops = new ResourceListN<6>;
    Resource *nexthops = hops->routed;


	int i = 0;
	// The coordinates of the destination
	int dx = d->x, dy = d->y;
	// The coordinates of the processing node at the end of channel c
	int nx = get_end(c).x, ny = get_end(c).y;


	if (dx != nx || dy != ny) {					// If we do not arrive at our destination
		if (c.p == W1 || c.p == E1 || c.p == N1 || c.p == S1 || c.p == L) {
			// We can route adaptively shortest path
			if (nx > 0 && dx < nx)
				nexthops[i++] = Resource(nx,ny,W1);//go west if the destination is west
			if (nx < (dim->x - 1) && dx > nx)
				nexthops[i++] = Resource(nx,ny,E1);//go east if the destination is east
			if (ny > 0 && dy < ny)
				nexthops[i++] = Resource(nx,ny,N1);//go north if the destination is north 
			if (ny < (dim->y - 1) && dy > ny)
				nexthops[i++] = Resource(nx,ny,S1);//go south if the destination is south 	
		}
		if (dx < nx)
			nexthops[i++] = Resource(nx,ny,W2);	//go west if the destination is west
		else if (dx > nx)
			nexthops[i++] = Resource(nx,ny,E2);	//go east if the destination is east
		else if (dy < ny)
			nexthops[i++] = Resource(nx,ny,N2);	//go north if the destination is north && in the right column
		else if (dy > ny)
			nexthops[i++] = Resource(nx,ny,S2);	//go south if the destination is south && in the right column
	}
	assert(i <= 6);
	return hops;
}

